<template>
  <div>
    <div
      v-if="!isNew"
      class="row"
    >
      <div class="col-xs-6">
        <ObDatePickerConstructor
          :value="dataSource.eventData && dataSource.eventData.occurredAt"
          label="Дата и время создания"
          :is-time="true"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Инициатор события"
          :value="dataSource.eventData && dataSource.eventData.authorTitle"
          :readonly="true"
        />
      </div>
    </div>
    <div class="row row-input">
      <ObStepper
        label="Число единиц"
        :model-value="formData.specialParameters && formData.specialParameters.unitQty"
        :min-value="1"
        :readonly="!isNew && !isNewForm"
        class="row-input__item row-input__counter"
        @input="onChangeField('specialParameters.unitQty', $event)"
      />
      <ObSelect
        :value="formData.specialParameters && formData.specialParameters.forwardingUnitUuid"
        label="Ед. экспед. учета"
        placeholder="Выберите"
        :remote-opt="getForwardingUnits"
        :is-standart="true"
        display-exp="denomination"
        :disabled="!isNew && !isNewForm"
        class="row-input__item"
        @input="onChangeField('specialParameters.forwardingUnitUuid', $event)"
      />
      <ObInput
        label="На сумму, без учета НДС"
        placeholder="Введите сумму"
        :value="formData.specialParameters && formData.specialParameters.amount"
        sub-title="₽"
        type="money:0"
        :readonly="!isNew && !isNewForm"
        class="row-input__item"
        @input="onChangeField('specialParameters.amount', $event)"
      />
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ObTextarea
          :value="formData.eventData && formData.eventData.comment"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="!isNew && !isNewForm"
          @input="onChangeField('eventData.comment', $event)"
        />
      </div>
    </div>
    <template v-if="formData.eventData && (!formData.eventData.fileUuids || !formData.eventData.fileUuids.length) && isEditMode && !isNewForm">
      <div class="title">Нет прикрепленных файлов</div>
    </template>
    <template v-if="(formData.eventData && formData.eventData.fileUuids && formData.eventData.fileUuids.length) || isNew || isNewForm">
      <div class="title">Прикрепленные файлы</div>
      <ObUploader
        ref="uploader"
        multiple
        :value="currentFiles"
        data-qa="uploader"
        :is-read-only="!isNew && !isNewForm"
        :upload-method="uploadMethod"
        @process-start="startUploadFiles"
        @change="onUploadHandler"
      />
    </template>
  </div>
</template>

<script>
import api from "@/api"
import ObInput from 'common-components/src/obComponents/obInput'
import ObSelect from 'common-components/src/obComponents/obSelect'
import ObStepper from 'common-components/src/obComponents/obStepper'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor'
import ObUploader from 'common-components/src/obComponents/obUploader'

export default {
  name: 'defectEventForm',
  components: {
    ObInput,
    ObSelect,
    ObStepper,
    ObTextarea,
    ObUploader,
    ObDatePickerConstructor
  },
  props: {
    formData: {
      type: Object,
      default: () => {}
    },
    isEditMode: {
      type: Boolean,
      default: false
    },
    isNew: {
      type: Boolean,
      default: false
    },
    isNewForm: {
      type: Boolean,
      default: false
    },
    dataSource: {
      type: Object,
      default: () => {}
    }
  },
  watch: {
    'formData.eventData.fileUuids'(value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    }
  },
  computed: {
    uploadMethod () {
      return api.files.postFile
    },
    currentFiles () {
      return this.dataSource.filesData
    }
  },
  methods: {
    startUploadFiles () {
      this.formData.eventData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      if (!data || !data.length) {
        this.onChangeField('eventData.fileUuids', null)
        return
      }

      this.onChangeField('eventData.fileUuids', data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    },
    async getForwardingUnits ({ query, page, size }) {
      const res = await api.resources.getForwardingUnitList(page, size, query)
      return res.data
    }
  }
}
</script>

<style lang="scss" scoped>
  .row-input {
    margin-right: 0;
    margin-left: 0;
    flex-wrap: nowrap;
    &__item {
      width: 212px;
      flex-grow: 2;
      &:not(:last-child) {
        margin-right: 10px;
      }
    }
    &__counter {
      width: 135px;
    }
  }
</style>